// BiosFix.cpp : ̨Ӧóڵ㡣
//

#include "stdafx.h"
#include <windows.h>

void GetAppFolderFileName(LPTSTR buffer, LPCTSTR shortFileName, UINT nBufSize);
DWORD VAToFA(DWORD va, PIMAGE_SECTION_HEADER pSectionHeaders, int NumberOfSections, DWORD ImageBase);
int ConvertToBytes(LPTSTR szHex, LPBYTE pBytes);
/*
 * 
 */
int _tmain(int argc, _TCHAR* argv[])
{
	TCHAR szFileName[MAX_PATH], szFileName_Fixed[MAX_PATH], szIniFile[MAX_PATH];
	IMAGE_DOS_HEADER dosHeader = { 0 };
	IMAGE_NT_HEADERS ntHeaders = { 0 };
	PIMAGE_SECTION_HEADER pSectionHeaders = NULL;

	//
	if(argc < 2)
	{
		_tprintf(_T("Input the source bios file[XXX.exe] to fix:\n"));
		_getts_s(szFileName, _ARRAYSIZE(szFileName));
	}
	else
	{
		_tcscpy_s(szFileName, _ARRAYSIZE(szFileName), argv[1]);
	}

	if(_taccess_s(szFileName, 0) != 0)
	{
		_tprintf(_T("The File Not Exist: [%s]\n"), szFileName);
		return 1;

	}
	
	TCHAR drive[_MAX_DRIVE], dir[_MAX_DIR], fname[_MAX_FNAME], ext[_MAX_EXT];

	_tsplitpath_s(szFileName,
		drive, _MAX_DRIVE,
		dir, _MAX_DIR,
		fname, _MAX_FNAME,
		ext, _MAX_EXT);


	GetAppFolderFileName(szIniFile, _T("BiosFix.ini"), MAX_PATH);
	int VACount = (int)GetPrivateProfileInt(fname, _T("Count"), -1, szIniFile);
	if(VACount <= 0)
	{
		_tprintf(_T("Donot have this bios's fix information.\n"));
		_tprintf(_T("Feedback to http:\\\\www.cnblogs.com\\hoodlum1980 to get help.\n"));
		return 101;
	}
	

	_stprintf_s(szFileName_Fixed, MAX_PATH, _T("%s%s%s_Fixed%s"),
		drive, dir, fname, ext);

	if(!CopyFile(szFileName, szFileName_Fixed, FALSE))
	{
		_tprintf(_T("Cannot Copy File.\n"));
		return 2;
	}

	//open file
	FILE *fp = NULL;
	errno_t err = _tfopen_s(&fp, szFileName_Fixed, _T("r+b"));
	if(err != 0 || fp == NULL)
	{
		_tprintf(_T("Cannot Open File: [%s]\n"), szFileName_Fixed);
		return 3;

	}

	size_t count = fread(&dosHeader, sizeof(IMAGE_DOS_HEADER), 1, fp);
	fseek(fp, dosHeader.e_lfanew, SEEK_SET);
	count = fread(&ntHeaders, sizeof(IMAGE_NT_HEADERS), 1, fp);

	//alloc sectionHeaders
	pSectionHeaders = (PIMAGE_SECTION_HEADER)malloc(sizeof(IMAGE_SECTION_HEADER) * ntHeaders.FileHeader.NumberOfSections);
	if(pSectionHeaders == NULL)
	{
		fclose(fp);
		_tprintf(_T("Cannot Alloc memory for SectionHeaders.\n"));
		return 4;
	}
	count = fread(pSectionHeaders, sizeof(IMAGE_SECTION_HEADER), ntHeaders.FileHeader.NumberOfSections, fp);

	_tprintf(_T("ImageBase: %08XH\n"), ntHeaders.OptionalHeader.ImageBase);
	_tprintf(_T("NumberOfSections: %ld\n"), ntHeaders.FileHeader.NumberOfSections);

	//ȡļ
	int index;
	TCHAR szBuf[128], szMemo[128];
	TCHAR szAddr[16], szValueName[32], *pEndChar = NULL;
	DWORD dwVA, dwFA; //VirualAddress of Instuction, FileAddress;
	BYTE bytesOld[32], bytesNew[32], bytesInFile[32];
	int countOld, countNew;
	
	//16ַֹʽת
	for(index = 1; index <= VACount; index++)
	{
		_tprintf(_T("----------------[FixNo: %02d]-----------------\n"), index);
		//______0123456789A
		//Addr1=VA:XXXXXXXX / FA:XXXXXXXX
		_stprintf_s(szValueName, _ARRAYSIZE(szValueName), _T("Addr%ld"), index);
		GetPrivateProfileString(fname, szValueName, _T(""), szAddr, _ARRAYSIZE(szAddr), szIniFile);

		_stprintf_s(szValueName, _ARRAYSIZE(szValueName), _T("Old%ld"), index);
		GetPrivateProfileString(fname, szValueName, _T(""), szBuf, _ARRAYSIZE(szBuf), szIniFile);
		countOld = ConvertToBytes(szBuf, bytesOld);

		_stprintf_s(szValueName, _ARRAYSIZE(szValueName), _T("New%ld"), index);
		GetPrivateProfileString(fname, szValueName, _T(""), szBuf, _ARRAYSIZE(szBuf), szIniFile);
		countNew = ConvertToBytes(szBuf, bytesNew);

		_stprintf_s(szValueName, _ARRAYSIZE(szValueName), _T("Memo%ld"), index);
		GetPrivateProfileString(fname, szValueName, _T(""), szMemo, _ARRAYSIZE(szMemo), szIniFile);

		dwVA = _tcstoul(szAddr + 3, &pEndChar, 16);

		//ǰ׺"VA:"תļַ
		if(szAddr[0] == _T('V'))
		{
			_tprintf(_T("VA: %08XH\n"), dwVA);
			dwFA = VAToFA(dwVA, pSectionHeaders, 
				ntHeaders.FileHeader.NumberOfSections, 
				ntHeaders.OptionalHeader.ImageBase);
		}
		else
		{
			//"FA:"
			dwFA = dwVA;
		}
		_tprintf(_T("FA: %08XH\n"), dwFA);
		
		fseek(fp, dwFA, SEEK_SET);
		fread(bytesInFile, 1, countOld, fp);
		if(memcmp(bytesInFile, bytesOld, countOld) != 0)
		{
			_tprintf(_T("File's Original Content Not Match!\n"));
			return 102;
		}

		//right after switch r/w mode, must seek first!
		fseek(fp, dwFA, SEEK_SET);
		if(fwrite(bytesNew, 1, countNew, fp) == countNew)
		{
			_tprintf(_T("Overwrite %ld Bytes (%s);\n"), countNew, szMemo);
		}
	}

	free(pSectionHeaders);
	fclose(fp);

	_tprintf(_T("----------------[Fix Completed!]-----------------\n"), index);
	_tprintf(_T("The Fixed File is:\n%s\n"), szFileName_Fixed);
	return 0;
}

void GetAppFolderFileName(LPTSTR buffer, LPCTSTR shortFileName, UINT nBufSize)
{
	//ӦóĿ¼(βбַ)
	TCHAR szAppFolder[MAX_PATH];

	TCHAR *pChar = NULL;
	GetModuleFileName(NULL, szAppFolder, MAX_PATH);

	pChar = _tcsrchr(szAppFolder, _T('\\'));
	if(pChar != NULL)
	{
		*pChar = 0;
	}
	
	if(shortFileName == NULL)
		_tcscpy_s(buffer, nBufSize, szAppFolder);
	else
		_stprintf_s(buffer, nBufSize, _T("%s\\%s"), szAppFolder, shortFileName);
}

//VAַתļַ
DWORD VAToFA(DWORD va, PIMAGE_SECTION_HEADER pSectionHeaders, int NumberOfSections, DWORD ImageBase)
{
	int i, iSection = -1;
	DWORD rva = va - ImageBase;

	//ҸRvaλǸ
	for(i = 0; i < NumberOfSections; i++)
	{
		if(rva >= pSectionHeaders[i].VirtualAddress
			&& (rva <= pSectionHeaders[i].VirtualAddress + pSectionHeaders[i].Misc.VirtualSize))
		{
			//rvaλڸö
			iSection = i;
			break;
		}
	}

	//δҵ
	if(iSection < 0)
		return 0;

	//
	return pSectionHeaders[iSection].PointerToRawData + (rva - pSectionHeaders[iSection].VirtualAddress);
}

//ֽ, ó 32 Bytes
//"AB CD" -> { 0xAB, 0xCD };
int ConvertToBytes(LPTSTR szHex, LPBYTE pBytes)
{
	int index = 0;
	int len = _tcslen(szHex);

	//95 = 3 * 32 - 1
	if(len > 95)
		return 0;

	LPTSTR pCh = szHex;
	TCHAR *pEndChar;
	
	while(TRUE)
	{
		pBytes[index] = (BYTE)_tcstoul(pCh, &pEndChar, 16);
		++index;
		if(*pEndChar == 0)
			break;

		pCh = pEndChar + 1;
	}
	return index;
}